
# WizLib

A framework for command-line devops and personal productivity tools

WizLib wraps the built-in ArgumentParser with a set of functions, classes, and conventions that enables:

- Easy addition of loosely coupled new subcommands
- Unified access to configuration files with a normalized approach
- Standardized use of stdin, stdout, and stderr
- Plugin-type system for handling alternate UIs (such as curses or even a web UI)
- Usable completion support for user input
- Abstracts some of the argparse complexity
- Applies conventions to application code structure
- Supports test-driven development and CICD

## Getting started

- [Home page](https://wizlib.ca) with documentation
- [Sample project](https://gitlab.com/wizlib/sample) to get started
- [Related projects](https://gitlab.com/wizlib) for real-world examples

---

Logo by [Freepik](https://www.freepik.com/?_gl=1*1y9rvc9*test_ga*Mjc1MTIzODYxLjE2ODA3OTczNTg.*test_ga_523JXC6VL7*MTY4MDc5NzM1OC4xLjEuMTY4MDc5NzQxNS4zLjAuMA..*fp_ga*Mjc1MTIzODYxLjE2ODA3OTczNTg.*fp_ga_1ZY8468CQB*MTY4MDc5NzM1OC4xLjEuMTY4MDc5NzQxNS4zLjAuMA..)


